VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "RijndaelStatic"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'    CopyRight (c) 2006 Kelly Ethridge
'
'    This file is part of VBCorLib.
'
'    VBCorLib is free software; you can redistribute it and/or modify
'    it under the terms of the GNU Library General Public License as published by
'    the Free Software Foundation; either version 2.1 of the License, or
'    (at your option) any later version.
'
'    VBCorLib is distributed in the hope that it will be useful,
'    but WITHOUT ANY WARRANTY; without even the implied warranty of
'    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'    GNU Library General Public License for more details.
'
'    You should have received a copy of the GNU Library General Public License
'    along with Foobar; if not, write to the Free Software
'    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
'
'    Module: RijndaelStatic
'

''
' Provides static methods associated with the Rijndael class.
'
Option Explicit

Private mTe0()      As Long
Private mTe1()      As Long
Private mTe2()      As Long
Private mTe3()      As Long
Private mTe4()      As Long
Private mTd0()      As Long
Private mTd1()      As Long
Private mTd2()      As Long
Private mTd3()      As Long
Private mTd4()      As Long
Private mRCon()     As Long
Private mSBox()     As Byte

Private mTe0Ptr     As Long
Private mTe1Ptr     As Long
Private mTe2Ptr     As Long
Private mTe3Ptr     As Long
Private mTe4Ptr     As Long
Private mTd0Ptr     As Long
Private mTd1Ptr     As Long
Private mTd2Ptr     As Long
Private mTd3Ptr     As Long
Private mTd4Ptr     As Long
Private mRConPtr    As Long
Private mSBoxPtr    As Long



''
' Returns an implementation of the Rijndael algorithm based on the name.
'
' @param AlgName The name of the specific implementation.
' @return An implementation of the Rijndael alogrithm.
' @remarks If "Rijndael" or "RijndaelManaged" are passed in, then the
' default implementation <b>RijndaelManaged</b> is returned.
'
Public Function Create(Optional ByVal AlgName As String = "Rijndael") As Rijndael
    Set Create = CryptoConfig.CreateFromName(AlgName)
End Function


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'   Friend Interface
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Friend Property Get Te0Ptr() As Long
    If mTe0Ptr = vbNullPtr Then Call InitTe0
    Te0Ptr = mTe0Ptr
End Property

Friend Property Get Te1Ptr() As Long
    If mTe1Ptr = vbNullPtr Then Call InitTe1
    Te1Ptr = mTe1Ptr
End Property

Friend Property Get Te2Ptr() As Long
    If mTe2Ptr = vbNullPtr Then Call InitTe2
    Te2Ptr = mTe2Ptr
End Property

Friend Property Get Te3Ptr() As Long
    If mTe3Ptr = vbNullPtr Then Call InitTe3
    Te3Ptr = mTe3Ptr
End Property

Friend Property Get Te4Ptr() As Long
    If mTe4Ptr = vbNullPtr Then Call InitTe4
    Te4Ptr = mTe4Ptr
End Property

Friend Property Get Td0Ptr() As Long
    If mTd0Ptr = vbNullPtr Then Call InitTd0
    Td0Ptr = mTd0Ptr
End Property

Friend Property Get Td1Ptr() As Long
    If mTd1Ptr = vbNullPtr Then Call InitTd1
    Td1Ptr = mTd1Ptr
End Property

Friend Property Get Td2Ptr() As Long
    If mTd2Ptr = vbNullPtr Then Call InitTd2
    Td2Ptr = mTd2Ptr
End Property

Friend Property Get Td3Ptr() As Long
    If mTd3Ptr = vbNullPtr Then Call InitTd3
    Td3Ptr = mTd3Ptr
End Property

Friend Property Get Td4Ptr() As Long
    If mTd4Ptr = vbNullPtr Then Call InitTd4
    Td4Ptr = mTd4Ptr
End Property

Friend Property Get RConPtr() As Long
    If mRConPtr = vbNullPtr Then Call InitRCon
    RConPtr = mRConPtr
End Property

Friend Property Get SBoxPtr() As Long
    If mSBoxPtr = vbNullPtr Then Call InitSBox
    SBoxPtr = mSBoxPtr
End Property


'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
'   Private Helpers
'''''''''''''''''''''''''''''''''''''''''''''''''''''''''''''
Private Sub InitTe0()
    mTe0 = Cor.NewLongs( _
        &HA56363C6, &H847C7CF8, &H997777EE, &H8D7B7BF6, &HDF2F2FF, &HBD6B6BD6, &HB16F6FDE, &H54C5C591, &H50303060, &H3010102, &HA96767CE, &H7D2B2B56, &H19FEFEE7, &H62D7D7B5, &HE6ABAB4D, &H9A7676EC, _
        &H45CACA8F, &H9D82821F, &H40C9C989, &H877D7DFA, &H15FAFAEF, &HEB5959B2, &HC947478E, &HBF0F0FB, &HECADAD41, &H67D4D4B3, &HFDA2A25F, &HEAAFAF45, &HBF9C9C23, &HF7A4A453, &H967272E4, &H5BC0C09B, _
        &HC2B7B775, &H1CFDFDE1, &HAE93933D, &H6A26264C, &H5A36366C, &H413F3F7E, &H2F7F7F5, &H4FCCCC83, &H5C343468, &HF4A5A551, &H34E5E5D1, &H8F1F1F9, &H937171E2, &H73D8D8AB, &H53313162, &H3F15152A, _
        &HC040408, &H52C7C795, &H65232346, &H5EC3C39D, &H28181830, &HA1969637, &HF05050A, &HB59A9A2F, &H907070E, &H36121224, &H9B80801B, &H3DE2E2DF, &H26EBEBCD, &H6927274E, &HCDB2B27F, &H9F7575EA, _
        &H1B090912, &H9E83831D, &H742C2C58, &H2E1A1A34, &H2D1B1B36, &HB26E6EDC, &HEE5A5AB4, &HFBA0A05B, &HF65252A4, &H4D3B3B76, &H61D6D6B7, &HCEB3B37D, &H7B292952, &H3EE3E3DD, &H712F2F5E, &H97848413, _
        &HF55353A6, &H68D1D1B9, &H0&, &H2CEDEDC1, &H60202040, &H1FFCFCE3, &HC8B1B179, &HED5B5BB6, &HBE6A6AD4, &H46CBCB8D, &HD9BEBE67, &H4B393972, &HDE4A4A94, &HD44C4C98, &HE85858B0, &H4ACFCF85, _
        &H6BD0D0BB, &H2AEFEFC5, &HE5AAAA4F, &H16FBFBED, &HC5434386, &HD74D4D9A, &H55333366, &H94858511, &HCF45458A, &H10F9F9E9, &H6020204, &H817F7FFE, &HF05050A0, &H443C3C78, &HBA9F9F25, &HE3A8A84B, _
        &HF35151A2, &HFEA3A35D, &HC0404080, &H8A8F8F05, &HAD92923F, &HBC9D9D21, &H48383870, &H4F5F5F1, &HDFBCBC63, &HC1B6B677, &H75DADAAF, &H63212142, &H30101020, &H1AFFFFE5, &HEF3F3FD, &H6DD2D2BF, _
        &H4CCDCD81, &H140C0C18, &H35131326, &H2FECECC3, &HE15F5FBE, &HA2979735, &HCC444488, &H3917172E, &H57C4C493, &HF2A7A755, &H827E7EFC, &H473D3D7A, &HAC6464C8, &HE75D5DBA, &H2B191932, &H957373E6, _
        &HA06060C0, &H98818119, &HD14F4F9E, &H7FDCDCA3, &H66222244, &H7E2A2A54, &HAB90903B, &H8388880B, &HCA46468C, &H29EEEEC7, &HD3B8B86B, &H3C141428, &H79DEDEA7, &HE25E5EBC, &H1D0B0B16, &H76DBDBAD, _
        &H3BE0E0DB, &H56323264, &H4E3A3A74, &H1E0A0A14, &HDB494992, &HA06060C, &H6C242448, &HE45C5CB8, &H5DC2C29F, &H6ED3D3BD, &HEFACAC43, &HA66262C4, &HA8919139, &HA4959531, &H37E4E4D3, &H8B7979F2, _
        &H32E7E7D5, &H43C8C88B, &H5937376E, &HB76D6DDA, &H8C8D8D01, &H64D5D5B1, &HD24E4E9C, &HE0A9A949, &HB46C6CD8, &HFA5656AC, &H7F4F4F3, &H25EAEACF, &HAF6565CA, &H8E7A7AF4, &HE9AEAE47, &H18080810, _
        &HD5BABA6F, &H887878F0, &H6F25254A, &H722E2E5C, &H241C1C38, &HF1A6A657, &HC7B4B473, &H51C6C697, &H23E8E8CB, &H7CDDDDA1, &H9C7474E8, &H211F1F3E, &HDD4B4B96, &HDCBDBD61, &H868B8B0D, &H858A8A0F, _
        &H907070E0, &H423E3E7C, &HC4B5B571, &HAA6666CC, &HD8484890, &H5030306, &H1F6F6F7, &H120E0E1C, &HA36161C2, &H5F35356A, &HF95757AE, &HD0B9B969, &H91868617, &H58C1C199, &H271D1D3A, &HB99E9E27, _
        &H38E1E1D9, &H13F8F8EB, &HB398982B, &H33111122, &HBB6969D2, &H70D9D9A9, &H898E8E07, &HA7949433, &HB69B9B2D, &H221E1E3C, &H92878715, &H20E9E9C9, &H49CECE87, &HFF5555AA, &H78282850, &H7ADFDFA5, _
        &H8F8C8C03, &HF8A1A159, &H80898909, &H170D0D1A, &HDABFBF65, &H31E6E6D7, &HC6424284, &HB86868D0, &HC3414182, &HB0999929, &H772D2D5A, &H110F0F1E, &HCBB0B07B, &HFC5454A8, &HD6BBBB6D, &H3A16162C)
    
    mTe0Ptr = VarPtr(mTe0(0))
End Sub

Private Sub InitTe1()
    mTe1 = Cor.NewLongs( _
        &H6363C6A5, &H7C7CF884, &H7777EE99, &H7B7BF68D, &HF2F2FF0D, &H6B6BD6BD, &H6F6FDEB1, &HC5C59154, &H30306050, &H1010203, &H6767CEA9, &H2B2B567D, &HFEFEE719, &HD7D7B562, &HABAB4DE6, &H7676EC9A, _
        &HCACA8F45, &H82821F9D, &HC9C98940, &H7D7DFA87, &HFAFAEF15, &H5959B2EB, &H47478EC9, &HF0F0FB0B, &HADAD41EC, &HD4D4B367, &HA2A25FFD, &HAFAF45EA, &H9C9C23BF, &HA4A453F7, &H7272E496, &HC0C09B5B, _
        &HB7B775C2, &HFDFDE11C, &H93933DAE, &H26264C6A, &H36366C5A, &H3F3F7E41, &HF7F7F502, &HCCCC834F, &H3434685C, &HA5A551F4, &HE5E5D134, &HF1F1F908, &H7171E293, &HD8D8AB73, &H31316253, &H15152A3F, _
        &H404080C, &HC7C79552, &H23234665, &HC3C39D5E, &H18183028, &H969637A1, &H5050A0F, &H9A9A2FB5, &H7070E09, &H12122436, &H80801B9B, &HE2E2DF3D, &HEBEBCD26, &H27274E69, &HB2B27FCD, &H7575EA9F, _
        &H909121B, &H83831D9E, &H2C2C5874, &H1A1A342E, &H1B1B362D, &H6E6EDCB2, &H5A5AB4EE, &HA0A05BFB, &H5252A4F6, &H3B3B764D, &HD6D6B761, &HB3B37DCE, &H2929527B, &HE3E3DD3E, &H2F2F5E71, &H84841397, _
        &H5353A6F5, &HD1D1B968, &H0&, &HEDEDC12C, &H20204060, &HFCFCE31F, &HB1B179C8, &H5B5BB6ED, &H6A6AD4BE, &HCBCB8D46, &HBEBE67D9, &H3939724B, &H4A4A94DE, &H4C4C98D4, &H5858B0E8, &HCFCF854A, _
        &HD0D0BB6B, &HEFEFC52A, &HAAAA4FE5, &HFBFBED16, &H434386C5, &H4D4D9AD7, &H33336655, &H85851194, &H45458ACF, &HF9F9E910, &H2020406, &H7F7FFE81, &H5050A0F0, &H3C3C7844, &H9F9F25BA, &HA8A84BE3, _
        &H5151A2F3, &HA3A35DFE, &H404080C0, &H8F8F058A, &H92923FAD, &H9D9D21BC, &H38387048, &HF5F5F104, &HBCBC63DF, &HB6B677C1, &HDADAAF75, &H21214263, &H10102030, &HFFFFE51A, &HF3F3FD0E, &HD2D2BF6D, _
        &HCDCD814C, &HC0C1814, &H13132635, &HECECC32F, &H5F5FBEE1, &H979735A2, &H444488CC, &H17172E39, &HC4C49357, &HA7A755F2, &H7E7EFC82, &H3D3D7A47, &H6464C8AC, &H5D5DBAE7, &H1919322B, &H7373E695, _
        &H6060C0A0, &H81811998, &H4F4F9ED1, &HDCDCA37F, &H22224466, &H2A2A547E, &H90903BAB, &H88880B83, &H46468CCA, &HEEEEC729, &HB8B86BD3, &H1414283C, &HDEDEA779, &H5E5EBCE2, &HB0B161D, &HDBDBAD76, _
        &HE0E0DB3B, &H32326456, &H3A3A744E, &HA0A141E, &H494992DB, &H6060C0A, &H2424486C, &H5C5CB8E4, &HC2C29F5D, &HD3D3BD6E, &HACAC43EF, &H6262C4A6, &H919139A8, &H959531A4, &HE4E4D337, &H7979F28B, _
        &HE7E7D532, &HC8C88B43, &H37376E59, &H6D6DDAB7, &H8D8D018C, &HD5D5B164, &H4E4E9CD2, &HA9A949E0, &H6C6CD8B4, &H5656ACFA, &HF4F4F307, &HEAEACF25, &H6565CAAF, &H7A7AF48E, &HAEAE47E9, &H8081018, _
        &HBABA6FD5, &H7878F088, &H25254A6F, &H2E2E5C72, &H1C1C3824, &HA6A657F1, &HB4B473C7, &HC6C69751, &HE8E8CB23, &HDDDDA17C, &H7474E89C, &H1F1F3E21, &H4B4B96DD, &HBDBD61DC, &H8B8B0D86, &H8A8A0F85, _
        &H7070E090, &H3E3E7C42, &HB5B571C4, &H6666CCAA, &H484890D8, &H3030605, &HF6F6F701, &HE0E1C12, &H6161C2A3, &H35356A5F, &H5757AEF9, &HB9B969D0, &H86861791, &HC1C19958, &H1D1D3A27, &H9E9E27B9, _
        &HE1E1D938, &HF8F8EB13, &H98982BB3, &H11112233, &H6969D2BB, &HD9D9A970, &H8E8E0789, &H949433A7, &H9B9B2DB6, &H1E1E3C22, &H87871592, &HE9E9C920, &HCECE8749, &H5555AAFF, &H28285078, &HDFDFA57A, _
        &H8C8C038F, &HA1A159F8, &H89890980, &HD0D1A17, &HBFBF65DA, &HE6E6D731, &H424284C6, &H6868D0B8, &H414182C3, &H999929B0, &H2D2D5A77, &HF0F1E11, &HB0B07BCB, &H5454A8FC, &HBBBB6DD6, &H16162C3A)

    mTe1Ptr = VarPtr(mTe1(0))
End Sub

Private Sub InitTe2()
    mTe2 = Cor.NewLongs( _
        &H63C6A563, &H7CF8847C, &H77EE9977, &H7BF68D7B, &HF2FF0DF2, &H6BD6BD6B, &H6FDEB16F, &HC59154C5, &H30605030, &H1020301, &H67CEA967, &H2B567D2B, &HFEE719FE, &HD7B562D7, &HAB4DE6AB, &H76EC9A76, _
        &HCA8F45CA, &H821F9D82, &HC98940C9, &H7DFA877D, &HFAEF15FA, &H59B2EB59, &H478EC947, &HF0FB0BF0, &HAD41ECAD, &HD4B367D4, &HA25FFDA2, &HAF45EAAF, &H9C23BF9C, &HA453F7A4, &H72E49672, &HC09B5BC0, _
        &HB775C2B7, &HFDE11CFD, &H933DAE93, &H264C6A26, &H366C5A36, &H3F7E413F, &HF7F502F7, &HCC834FCC, &H34685C34, &HA551F4A5, &HE5D134E5, &HF1F908F1, &H71E29371, &HD8AB73D8, &H31625331, &H152A3F15, _
        &H4080C04, &HC79552C7, &H23466523, &HC39D5EC3, &H18302818, &H9637A196, &H50A0F05, &H9A2FB59A, &H70E0907, &H12243612, &H801B9B80, &HE2DF3DE2, &HEBCD26EB, &H274E6927, &HB27FCDB2, &H75EA9F75, _
        &H9121B09, &H831D9E83, &H2C58742C, &H1A342E1A, &H1B362D1B, &H6EDCB26E, &H5AB4EE5A, &HA05BFBA0, &H52A4F652, &H3B764D3B, &HD6B761D6, &HB37DCEB3, &H29527B29, &HE3DD3EE3, &H2F5E712F, &H84139784, _
        &H53A6F553, &HD1B968D1, &H0&, &HEDC12CED, &H20406020, &HFCE31FFC, &HB179C8B1, &H5BB6ED5B, &H6AD4BE6A, &HCB8D46CB, &HBE67D9BE, &H39724B39, &H4A94DE4A, &H4C98D44C, &H58B0E858, &HCF854ACF, _
        &HD0BB6BD0, &HEFC52AEF, &HAA4FE5AA, &HFBED16FB, &H4386C543, &H4D9AD74D, &H33665533, &H85119485, &H458ACF45, &HF9E910F9, &H2040602, &H7FFE817F, &H50A0F050, &H3C78443C, &H9F25BA9F, &HA84BE3A8, _
        &H51A2F351, &HA35DFEA3, &H4080C040, &H8F058A8F, &H923FAD92, &H9D21BC9D, &H38704838, &HF5F104F5, &HBC63DFBC, &HB677C1B6, &HDAAF75DA, &H21426321, &H10203010, &HFFE51AFF, &HF3FD0EF3, &HD2BF6DD2, _
        &HCD814CCD, &HC18140C, &H13263513, &HECC32FEC, &H5FBEE15F, &H9735A297, &H4488CC44, &H172E3917, &HC49357C4, &HA755F2A7, &H7EFC827E, &H3D7A473D, &H64C8AC64, &H5DBAE75D, &H19322B19, &H73E69573, _
        &H60C0A060, &H81199881, &H4F9ED14F, &HDCA37FDC, &H22446622, &H2A547E2A, &H903BAB90, &H880B8388, &H468CCA46, &HEEC729EE, &HB86BD3B8, &H14283C14, &HDEA779DE, &H5EBCE25E, &HB161D0B, &HDBAD76DB, _
        &HE0DB3BE0, &H32645632, &H3A744E3A, &HA141E0A, &H4992DB49, &H60C0A06, &H24486C24, &H5CB8E45C, &HC29F5DC2, &HD3BD6ED3, &HAC43EFAC, &H62C4A662, &H9139A891, &H9531A495, &HE4D337E4, &H79F28B79, _
        &HE7D532E7, &HC88B43C8, &H376E5937, &H6DDAB76D, &H8D018C8D, &HD5B164D5, &H4E9CD24E, &HA949E0A9, &H6CD8B46C, &H56ACFA56, &HF4F307F4, &HEACF25EA, &H65CAAF65, &H7AF48E7A, &HAE47E9AE, &H8101808, _
        &HBA6FD5BA, &H78F08878, &H254A6F25, &H2E5C722E, &H1C38241C, &HA657F1A6, &HB473C7B4, &HC69751C6, &HE8CB23E8, &HDDA17CDD, &H74E89C74, &H1F3E211F, &H4B96DD4B, &HBD61DCBD, &H8B0D868B, &H8A0F858A, _
        &H70E09070, &H3E7C423E, &HB571C4B5, &H66CCAA66, &H4890D848, &H3060503, &HF6F701F6, &HE1C120E, &H61C2A361, &H356A5F35, &H57AEF957, &HB969D0B9, &H86179186, &HC19958C1, &H1D3A271D, &H9E27B99E, _
        &HE1D938E1, &HF8EB13F8, &H982BB398, &H11223311, &H69D2BB69, &HD9A970D9, &H8E07898E, &H9433A794, &H9B2DB69B, &H1E3C221E, &H87159287, &HE9C920E9, &HCE8749CE, &H55AAFF55, &H28507828, &HDFA57ADF, _
        &H8C038F8C, &HA159F8A1, &H89098089, &HD1A170D, &HBF65DABF, &HE6D731E6, &H4284C642, &H68D0B868, &H4182C341, &H9929B099, &H2D5A772D, &HF1E110F, &HB07BCBB0, &H54A8FC54, &HBB6DD6BB, &H162C3A16)

    mTe2Ptr = VarPtr(mTe2(0))
End Sub

Private Sub InitTe3()
    mTe3 = Cor.NewLongs( _
        &HC6A56363, &HF8847C7C, &HEE997777, &HF68D7B7B, &HFF0DF2F2, &HD6BD6B6B, &HDEB16F6F, &H9154C5C5, &H60503030, &H2030101, &HCEA96767, &H567D2B2B, &HE719FEFE, &HB562D7D7, &H4DE6ABAB, &HEC9A7676, _
        &H8F45CACA, &H1F9D8282, &H8940C9C9, &HFA877D7D, &HEF15FAFA, &HB2EB5959, &H8EC94747, &HFB0BF0F0, &H41ECADAD, &HB367D4D4, &H5FFDA2A2, &H45EAAFAF, &H23BF9C9C, &H53F7A4A4, &HE4967272, &H9B5BC0C0, _
        &H75C2B7B7, &HE11CFDFD, &H3DAE9393, &H4C6A2626, &H6C5A3636, &H7E413F3F, &HF502F7F7, &H834FCCCC, &H685C3434, &H51F4A5A5, &HD134E5E5, &HF908F1F1, &HE2937171, &HAB73D8D8, &H62533131, &H2A3F1515, _
        &H80C0404, &H9552C7C7, &H46652323, &H9D5EC3C3, &H30281818, &H37A19696, &HA0F0505, &H2FB59A9A, &HE090707, &H24361212, &H1B9B8080, &HDF3DE2E2, &HCD26EBEB, &H4E692727, &H7FCDB2B2, &HEA9F7575, _
        &H121B0909, &H1D9E8383, &H58742C2C, &H342E1A1A, &H362D1B1B, &HDCB26E6E, &HB4EE5A5A, &H5BFBA0A0, &HA4F65252, &H764D3B3B, &HB761D6D6, &H7DCEB3B3, &H527B2929, &HDD3EE3E3, &H5E712F2F, &H13978484, _
        &HA6F55353, &HB968D1D1, &H0&, &HC12CEDED, &H40602020, &HE31FFCFC, &H79C8B1B1, &HB6ED5B5B, &HD4BE6A6A, &H8D46CBCB, &H67D9BEBE, &H724B3939, &H94DE4A4A, &H98D44C4C, &HB0E85858, &H854ACFCF, _
        &HBB6BD0D0, &HC52AEFEF, &H4FE5AAAA, &HED16FBFB, &H86C54343, &H9AD74D4D, &H66553333, &H11948585, &H8ACF4545, &HE910F9F9, &H4060202, &HFE817F7F, &HA0F05050, &H78443C3C, &H25BA9F9F, &H4BE3A8A8, _
        &HA2F35151, &H5DFEA3A3, &H80C04040, &H58A8F8F, &H3FAD9292, &H21BC9D9D, &H70483838, &HF104F5F5, &H63DFBCBC, &H77C1B6B6, &HAF75DADA, &H42632121, &H20301010, &HE51AFFFF, &HFD0EF3F3, &HBF6DD2D2, _
        &H814CCDCD, &H18140C0C, &H26351313, &HC32FECEC, &HBEE15F5F, &H35A29797, &H88CC4444, &H2E391717, &H9357C4C4, &H55F2A7A7, &HFC827E7E, &H7A473D3D, &HC8AC6464, &HBAE75D5D, &H322B1919, &HE6957373, _
        &HC0A06060, &H19988181, &H9ED14F4F, &HA37FDCDC, &H44662222, &H547E2A2A, &H3BAB9090, &HB838888, &H8CCA4646, &HC729EEEE, &H6BD3B8B8, &H283C1414, &HA779DEDE, &HBCE25E5E, &H161D0B0B, &HAD76DBDB, _
        &HDB3BE0E0, &H64563232, &H744E3A3A, &H141E0A0A, &H92DB4949, &HC0A0606, &H486C2424, &HB8E45C5C, &H9F5DC2C2, &HBD6ED3D3, &H43EFACAC, &HC4A66262, &H39A89191, &H31A49595, &HD337E4E4, &HF28B7979, _
        &HD532E7E7, &H8B43C8C8, &H6E593737, &HDAB76D6D, &H18C8D8D, &HB164D5D5, &H9CD24E4E, &H49E0A9A9, &HD8B46C6C, &HACFA5656, &HF307F4F4, &HCF25EAEA, &HCAAF6565, &HF48E7A7A, &H47E9AEAE, &H10180808, _
        &H6FD5BABA, &HF0887878, &H4A6F2525, &H5C722E2E, &H38241C1C, &H57F1A6A6, &H73C7B4B4, &H9751C6C6, &HCB23E8E8, &HA17CDDDD, &HE89C7474, &H3E211F1F, &H96DD4B4B, &H61DCBDBD, &HD868B8B, &HF858A8A, _
        &HE0907070, &H7C423E3E, &H71C4B5B5, &HCCAA6666, &H90D84848, &H6050303, &HF701F6F6, &H1C120E0E, &HC2A36161, &H6A5F3535, &HAEF95757, &H69D0B9B9, &H17918686, &H9958C1C1, &H3A271D1D, &H27B99E9E, _
        &HD938E1E1, &HEB13F8F8, &H2BB39898, &H22331111, &HD2BB6969, &HA970D9D9, &H7898E8E, &H33A79494, &H2DB69B9B, &H3C221E1E, &H15928787, &HC920E9E9, &H8749CECE, &HAAFF5555, &H50782828, &HA57ADFDF, _
        &H38F8C8C, &H59F8A1A1, &H9808989, &H1A170D0D, &H65DABFBF, &HD731E6E6, &H84C64242, &HD0B86868, &H82C34141, &H29B09999, &H5A772D2D, &H1E110F0F, &H7BCBB0B0, &HA8FC5454, &H6DD6BBBB, &H2C3A1616)

    mTe3Ptr = VarPtr(mTe3(0))
End Sub

Private Sub InitTe4()
    mTe4 = Cor.NewLongs( _
        &H63636363, &H7C7C7C7C, &H77777777, &H7B7B7B7B, &HF2F2F2F2, &H6B6B6B6B, &H6F6F6F6F, &HC5C5C5C5, &H30303030, &H1010101, &H67676767, &H2B2B2B2B, &HFEFEFEFE, &HD7D7D7D7, &HABABABAB, &H76767676, _
        &HCACACACA, &H82828282, &HC9C9C9C9, &H7D7D7D7D, &HFAFAFAFA, &H59595959, &H47474747, &HF0F0F0F0, &HADADADAD, &HD4D4D4D4, &HA2A2A2A2, &HAFAFAFAF, &H9C9C9C9C, &HA4A4A4A4, &H72727272, &HC0C0C0C0, _
        &HB7B7B7B7, &HFDFDFDFD, &H93939393, &H26262626, &H36363636, &H3F3F3F3F, &HF7F7F7F7, &HCCCCCCCC, &H34343434, &HA5A5A5A5, &HE5E5E5E5, &HF1F1F1F1, &H71717171, &HD8D8D8D8, &H31313131, &H15151515, _
        &H4040404, &HC7C7C7C7, &H23232323, &HC3C3C3C3, &H18181818, &H96969696, &H5050505, &H9A9A9A9A, &H7070707, &H12121212, &H80808080, &HE2E2E2E2, &HEBEBEBEB, &H27272727, &HB2B2B2B2, &H75757575, _
        &H9090909, &H83838383, &H2C2C2C2C, &H1A1A1A1A, &H1B1B1B1B, &H6E6E6E6E, &H5A5A5A5A, &HA0A0A0A0, &H52525252, &H3B3B3B3B, &HD6D6D6D6, &HB3B3B3B3, &H29292929, &HE3E3E3E3, &H2F2F2F2F, &H84848484, _
        &H53535353, &HD1D1D1D1, &H0, &HEDEDEDED, &H20202020, &HFCFCFCFC, &HB1B1B1B1, &H5B5B5B5B, &H6A6A6A6A, &HCBCBCBCB, &HBEBEBEBE, &H39393939, &H4A4A4A4A, &H4C4C4C4C, &H58585858, &HCFCFCFCF, _
        &HD0D0D0D0, &HEFEFEFEF, &HAAAAAAAA, &HFBFBFBFB, &H43434343, &H4D4D4D4D, &H33333333, &H85858585, &H45454545, &HF9F9F9F9, &H2020202, &H7F7F7F7F, &H50505050, &H3C3C3C3C, &H9F9F9F9F, &HA8A8A8A8, _
        &H51515151, &HA3A3A3A3, &H40404040, &H8F8F8F8F, &H92929292, &H9D9D9D9D, &H38383838, &HF5F5F5F5, &HBCBCBCBC, &HB6B6B6B6, &HDADADADA, &H21212121, &H10101010, &HFFFFFFFF, &HF3F3F3F3, &HD2D2D2D2, _
        &HCDCDCDCD, &HC0C0C0C, &H13131313, &HECECECEC, &H5F5F5F5F, &H97979797, &H44444444, &H17171717, &HC4C4C4C4, &HA7A7A7A7, &H7E7E7E7E, &H3D3D3D3D, &H64646464, &H5D5D5D5D, &H19191919, &H73737373, _
        &H60606060, &H81818181, &H4F4F4F4F, &HDCDCDCDC, &H22222222, &H2A2A2A2A, &H90909090, &H88888888, &H46464646, &HEEEEEEEE, &HB8B8B8B8, &H14141414, &HDEDEDEDE, &H5E5E5E5E, &HB0B0B0B, &HDBDBDBDB, _
        &HE0E0E0E0, &H32323232, &H3A3A3A3A, &HA0A0A0A, &H49494949, &H6060606, &H24242424, &H5C5C5C5C, &HC2C2C2C2, &HD3D3D3D3, &HACACACAC, &H62626262, &H91919191, &H95959595, &HE4E4E4E4, &H79797979, _
        &HE7E7E7E7, &HC8C8C8C8, &H37373737, &H6D6D6D6D, &H8D8D8D8D, &HD5D5D5D5, &H4E4E4E4E, &HA9A9A9A9, &H6C6C6C6C, &H56565656, &HF4F4F4F4, &HEAEAEAEA, &H65656565, &H7A7A7A7A, &HAEAEAEAE, &H8080808, _
        &HBABABABA, &H78787878, &H25252525, &H2E2E2E2E, &H1C1C1C1C, &HA6A6A6A6, &HB4B4B4B4, &HC6C6C6C6, &HE8E8E8E8, &HDDDDDDDD, &H74747474, &H1F1F1F1F, &H4B4B4B4B, &HBDBDBDBD, &H8B8B8B8B, &H8A8A8A8A, _
        &H70707070, &H3E3E3E3E, &HB5B5B5B5, &H66666666, &H48484848, &H3030303, &HF6F6F6F6, &HE0E0E0E, &H61616161, &H35353535, &H57575757, &HB9B9B9B9, &H86868686, &HC1C1C1C1, &H1D1D1D1D, &H9E9E9E9E, _
        &HE1E1E1E1, &HF8F8F8F8, &H98989898, &H11111111, &H69696969, &HD9D9D9D9, &H8E8E8E8E, &H94949494, &H9B9B9B9B, &H1E1E1E1E, &H87878787, &HE9E9E9E9, &HCECECECE, &H55555555, &H28282828, &HDFDFDFDF, _
        &H8C8C8C8C, &HA1A1A1A1, &H89898989, &HD0D0D0D, &HBFBFBFBF, &HE6E6E6E6, &H42424242, &H68686868, &H41414141, &H99999999, &H2D2D2D2D, &HF0F0F0F, &HB0B0B0B0, &H54545454, &HBBBBBBBB, &H16161616)

    mTe4Ptr = VarPtr(mTe4(0))
End Sub

Private Sub InitTd0()
    mTd0 = Cor.NewLongs( _
        &H50A7F451, &H5365417E, &HC3A4171A, &H965E273A, &HCB6BAB3B, &HF1459D1F, &HAB58FAAC, &H9303E34B, &H55FA3020, &HF66D76AD, &H9176CC88, &H254C02F5, &HFCD7E54F, &HD7CB2AC5, &H80443526, &H8FA362B5, _
        &H495AB1DE, &H671BBA25, &H980EEA45, &HE1C0FE5D, &H2752FC3, &H12F04C81, &HA397468D, &HC6F9D36B, &HE75F8F03, &H959C9215, &HEB7A6DBF, &HDA595295, &H2D83BED4, &HD3217458, &H2969E049, &H44C8C98E, _
        &H6A89C275, &H78798EF4, &H6B3E5899, &HDD71B927, &HB64FE1BE, &H17AD88F0, &H66AC20C9, &HB43ACE7D, &H184ADF63, &H82311AE5, &H60335197, &H457F5362, &HE07764B1, &H84AE6BBB, &H1CA081FE, &H942B08F9, _
        &H58684870, &H19FD458F, &H876CDE94, &HB7F87B52, &H23D373AB, &HE2024B72, &H578F1FE3, &H2AAB5566, &H728EBB2, &H3C2B52F, &H9A7BC586, &HA50837D3, &HF2872830, &HB2A5BF23, &HBA6A0302, &H5C8216ED, _
        &H2B1CCF8A, &H92B479A7, &HF0F207F3, &HA1E2694E, &HCDF4DA65, &HD5BE0506, &H1F6234D1, &H8AFEA6C4, &H9D532E34, &HA055F3A2, &H32E18A05, &H75EBF6A4, &H39EC830B, &HAAEF6040, &H69F715E, &H51106EBD, _
        &HF98A213E, &H3D06DD96, &HAE053EDD, &H46BDE64D, &HB58D5491, &H55DC471, &H6FD40604, &HFF155060, &H24FB9819, &H97E9BDD6, &HCC434089, &H779ED967, &HBD42E8B0, &H888B8907, &H385B19E7, &HDBEEC879, _
        &H470A7CA1, &HE90F427C, &HC91E84F8, &H0&, &H83868009, &H48ED2B32, &HAC70111E, &H4E725A6C, &HFBFF0EFD, &H5638850F, &H1ED5AE3D, &H27392D36, &H64D90F0A, &H21A65C68, &HD1545B9B, &H3A2E3624, _
        &HB1670A0C, &HFE75793, &HD296EEB4, &H9E919B1B, &H4FC5C080, &HA220DC61, &H694B775A, &H161A121C, &HABA93E2, &HE52AA0C0, &H43E0223C, &H1D171B12, &HB0D090E, &HADC78BF2, &HB9A8B62D, &HC8A91E14, _
        &H8519F157, &H4C0775AF, &HBBDD99EE, &HFD607FA3, &H9F2601F7, &HBCF5725C, &HC53B6644, &H347EFB5B, &H7629438B, &HDCC623CB, &H68FCEDB6, &H63F1E4B8, &HCADC31D7, &H10856342, &H40229713, &H2011C684, _
        &H7D244A85, &HF83DBBD2, &H1132F9AE, &H6DA129C7, &H4B2F9E1D, &HF330B2DC, &HEC52860D, &HD0E3C177, &H6C16B32B, &H99B970A9, &HFA489411, &H2264E947, &HC48CFCA8, &H1A3FF0A0, &HD82C7D56, &HEF903322, _
        &HC74E4987, &HC1D138D9, &HFEA2CA8C, &H360BD498, &HCF81F5A6, &H28DE7AA5, &H268EB7DA, &HA4BFAD3F, &HE49D3A2C, &HD927850, &H9BCC5F6A, &H62467E54, &HC2138DF6, &HE8B8D890, &H5EF7392E, &HF5AFC382, _
        &HBE805D9F, &H7C93D069, &HA92DD56F, &HB31225CF, &H3B99ACC8, &HA77D1810, &H6E639CE8, &H7BBB3BDB, &H97826CD, &HF418596E, &H1B79AEC, &HA89A4F83, &H656E95E6, &H7EE6FFAA, &H8CFBC21, &HE6E815EF, _
        &HD99BE7BA, &HCE366F4A, &HD4099FEA, &HD67CB029, &HAFB2A431, &H31233F2A, &H3094A5C6, &HC066A235, &H37BC4E74, &HA6CA82FC, &HB0D090E0, &H15D8A733, &H4A9804F1, &HF7DAEC41, &HE50CD7F, &H2FF69117, _
        &H8DD64D76, &H4DB0EF43, &H544DAACC, &HDF0496E4, &HE3B5D19E, &H1B886A4C, &HB81F2CC1, &H7F516546, &H4EA5E9D, &H5D358C01, &H737487FA, &H2E410BFB, &H5A1D67B3, &H52D2DB92, &H335610E9, &H1347D66D, _
        &H8C61D79A, &H7A0CA137, &H8E14F859, &H893C13EB, &HEE27A9CE, &H35C961B7, &HEDE51CE1, &H3CB1477A, &H59DFD29C, &H3F73F255, &H79CE1418, &HBF37C773, &HEACDF753, &H5BAAFD5F, &H146F3DDF, &H86DB4478, _
        &H81F3AFCA, &H3EC468B9, &H2C342438, &H5F40A3C2, &H72C31D16, &HC25E2BC, &H8B493C28, &H41950DFF, &H7101A839, &HDEB30C08, &H9CE4B4D8, &H90C15664, &H6184CB7B, &H70B632D5, &H745C6C48, &H4257B8D0)

    mTd0Ptr = VarPtr(mTd0(0))
End Sub

Private Sub InitTd1()
    mTd1 = Cor.NewLongs( _
        &HA7F45150, &H65417E53, &HA4171AC3, &H5E273A96, &H6BAB3BCB, &H459D1FF1, &H58FAACAB, &H3E34B93, &HFA302055, &H6D76ADF6, &H76CC8891, &H4C02F525, &HD7E54FFC, &HCB2AC5D7, &H44352680, &HA362B58F, _
        &H5AB1DE49, &H1BBA2567, &HEEA4598, &HC0FE5DE1, &H752FC302, &HF04C8112, &H97468DA3, &HF9D36BC6, &H5F8F03E7, &H9C921595, &H7A6DBFEB, &H595295DA, &H83BED42D, &H217458D3, &H69E04929, &HC8C98E44, _
        &H89C2756A, &H798EF478, &H3E58996B, &H71B927DD, &H4FE1BEB6, &HAD88F017, &HAC20C966, &H3ACE7DB4, &H4ADF6318, &H311AE582, &H33519760, &H7F536245, &H7764B1E0, &HAE6BBB84, &HA081FE1C, &H2B08F994, _
        &H68487058, &HFD458F19, &H6CDE9487, &HF87B52B7, &HD373AB23, &H24B72E2, &H8F1FE357, &HAB55662A, &H28EBB207, &HC2B52F03, &H7BC5869A, &H837D3A5, &H872830F2, &HA5BF23B2, &H6A0302BA, &H8216ED5C, _
        &H1CCF8A2B, &HB479A792, &HF207F3F0, &HE2694EA1, &HF4DA65CD, &HBE0506D5, &H6234D11F, &HFEA6C48A, &H532E349D, &H55F3A2A0, &HE18A0532, &HEBF6A475, &HEC830B39, &HEF6040AA, &H9F715E06, &H106EBD51, _
        &H8A213EF9, &H6DD963D, &H53EDDAE, &HBDE64D46, &H8D5491B5, &H5DC47105, &HD406046F, &H155060FF, &HFB981924, &HE9BDD697, &H434089CC, &H9ED96777, &H42E8B0BD, &H8B890788, &H5B19E738, &HEEC879DB, _
        &HA7CA147, &HF427CE9, &H1E84F8C9, &H0&, &H86800983, &HED2B3248, &H70111EAC, &H725A6C4E, &HFF0EFDFB, &H38850F56, &HD5AE3D1E, &H392D3627, &HD90F0A64, &HA65C6821, &H545B9BD1, &H2E36243A, _
        &H670A0CB1, &HE757930F, &H96EEB4D2, &H919B1B9E, &HC5C0804F, &H20DC61A2, &H4B775A69, &H1A121C16, &HBA93E20A, &H2AA0C0E5, &HE0223C43, &H171B121D, &HD090E0B, &HC78BF2AD, &HA8B62DB9, &HA91E14C8, _
        &H19F15785, &H775AF4C, &HDD99EEBB, &H607FA3FD, &H2601F79F, &HF5725CBC, &H3B6644C5, &H7EFB5B34, &H29438B76, &HC623CBDC, &HFCEDB668, &HF1E4B863, &HDC31D7CA, &H85634210, &H22971340, &H11C68420, _
        &H244A857D, &H3DBBD2F8, &H32F9AE11, &HA129C76D, &H2F9E1D4B, &H30B2DCF3, &H52860DEC, &HE3C177D0, &H16B32B6C, &HB970A999, &H489411FA, &H64E94722, &H8CFCA8C4, &H3FF0A01A, &H2C7D56D8, &H903322EF, _
        &H4E4987C7, &HD138D9C1, &HA2CA8CFE, &HBD49836, &H81F5A6CF, &HDE7AA528, &H8EB7DA26, &HBFAD3FA4, &H9D3A2CE4, &H9278500D, &HCC5F6A9B, &H467E5462, &H138DF6C2, &HB8D890E8, &HF7392E5E, &HAFC382F5, _
        &H805D9FBE, &H93D0697C, &H2DD56FA9, &H1225CFB3, &H99ACC83B, &H7D1810A7, &H639CE86E, &HBB3BDB7B, &H7826CD09, &H18596EF4, &HB79AEC01, &H9A4F83A8, &H6E95E665, &HE6FFAA7E, &HCFBC2108, &HE815EFE6, _
        &H9BE7BAD9, &H366F4ACE, &H99FEAD4, &H7CB029D6, &HB2A431AF, &H233F2A31, &H94A5C630, &H66A235C0, &HBC4E7437, &HCA82FCA6, &HD090E0B0, &HD8A73315, &H9804F14A, &HDAEC41F7, &H50CD7F0E, &HF691172F, _
        &HD64D768D, &HB0EF434D, &H4DAACC54, &H496E4DF, &HB5D19EE3, &H886A4C1B, &H1F2CC1B8, &H5165467F, &HEA5E9D04, &H358C015D, &H7487FA73, &H410BFB2E, &H1D67B35A, &HD2DB9252, &H5610E933, &H47D66D13, _
        &H61D79A8C, &HCA1377A, &H14F8598E, &H3C13EB89, &H27A9CEEE, &HC961B735, &HE51CE1ED, &HB1477A3C, &HDFD29C59, &H73F2553F, &HCE141879, &H37C773BF, &HCDF753EA, &HAAFD5F5B, &H6F3DDF14, &HDB447886, _
        &HF3AFCA81, &HC468B93E, &H3424382C, &H40A3C25F, &HC31D1672, &H25E2BC0C, &H493C288B, &H950DFF41, &H1A83971, &HB30C08DE, &HE4B4D89C, &HC1566490, &H84CB7B61, &HB632D570, &H5C6C4874, &H57B8D042)

    mTd1Ptr = VarPtr(mTd1(0))
End Sub

Private Sub InitTd2()
    mTd2 = Cor.NewLongs( _
        &HF45150A7, &H417E5365, &H171AC3A4, &H273A965E, &HAB3BCB6B, &H9D1FF145, &HFAACAB58, &HE34B9303, &H302055FA, &H76ADF66D, &HCC889176, &H2F5254C, &HE54FFCD7, &H2AC5D7CB, &H35268044, &H62B58FA3, _
        &HB1DE495A, &HBA25671B, &HEA45980E, &HFE5DE1C0, &H2FC30275, &H4C8112F0, &H468DA397, &HD36BC6F9, &H8F03E75F, &H9215959C, &H6DBFEB7A, &H5295DA59, &HBED42D83, &H7458D321, &HE0492969, &HC98E44C8, _
        &HC2756A89, &H8EF47879, &H58996B3E, &HB927DD71, &HE1BEB64F, &H88F017AD, &H20C966AC, &HCE7DB43A, &HDF63184A, &H1AE58231, &H51976033, &H5362457F, &H64B1E077, &H6BBB84AE, &H81FE1CA0, &H8F9942B, _
        &H48705868, &H458F19FD, &HDE94876C, &H7B52B7F8, &H73AB23D3, &H4B72E202, &H1FE3578F, &H55662AAB, &HEBB20728, &HB52F03C2, &HC5869A7B, &H37D3A508, &H2830F287, &HBF23B2A5, &H302BA6A, &H16ED5C82, _
        &HCF8A2B1C, &H79A792B4, &H7F3F0F2, &H694EA1E2, &HDA65CDF4, &H506D5BE, &H34D11F62, &HA6C48AFE, &H2E349D53, &HF3A2A055, &H8A0532E1, &HF6A475EB, &H830B39EC, &H6040AAEF, &H715E069F, &H6EBD5110, _
        &H213EF98A, &HDD963D06, &H3EDDAE05, &HE64D46BD, &H5491B58D, &HC471055D, &H6046FD4, &H5060FF15, &H981924FB, &HBDD697E9, &H4089CC43, &HD967779E, &HE8B0BD42, &H8907888B, &H19E7385B, &HC879DBEE, _
        &H7CA1470A, &H427CE90F, &H84F8C91E, &H0&, &H80098386, &H2B3248ED, &H111EAC70, &H5A6C4E72, &HEFDFBFF, &H850F5638, &HAE3D1ED5, &H2D362739, &HF0A64D9, &H5C6821A6, &H5B9BD154, &H36243A2E, _
        &HA0CB167, &H57930FE7, &HEEB4D296, &H9B1B9E91, &HC0804FC5, &HDC61A220, &H775A694B, &H121C161A, &H93E20ABA, &HA0C0E52A, &H223C43E0, &H1B121D17, &H90E0B0D, &H8BF2ADC7, &HB62DB9A8, &H1E14C8A9, _
        &HF1578519, &H75AF4C07, &H99EEBBDD, &H7FA3FD60, &H1F79F26, &H725CBCF5, &H6644C53B, &HFB5B347E, &H438B7629, &H23CBDCC6, &HEDB668FC, &HE4B863F1, &H31D7CADC, &H63421085, &H97134022, &HC6842011, _
        &H4A857D24, &HBBD2F83D, &HF9AE1132, &H29C76DA1, &H9E1D4B2F, &HB2DCF330, &H860DEC52, &HC177D0E3, &HB32B6C16, &H70A999B9, &H9411FA48, &HE9472264, &HFCA8C48C, &HF0A01A3F, &H7D56D82C, &H3322EF90, _
        &H4987C74E, &H38D9C1D1, &HCA8CFEA2, &HD498360B, &HF5A6CF81, &H7AA528DE, &HB7DA268E, &HAD3FA4BF, &H3A2CE49D, &H78500D92, &H5F6A9BCC, &H7E546246, &H8DF6C213, &HD890E8B8, &H392E5EF7, &HC382F5AF, _
        &H5D9FBE80, &HD0697C93, &HD56FA92D, &H25CFB312, &HACC83B99, &H1810A77D, &H9CE86E63, &H3BDB7BBB, &H26CD0978, &H596EF418, &H9AEC01B7, &H4F83A89A, &H95E6656E, &HFFAA7EE6, &HBC2108CF, &H15EFE6E8, _
        &HE7BAD99B, &H6F4ACE36, &H9FEAD409, &HB029D67C, &HA431AFB2, &H3F2A3123, &HA5C63094, &HA235C066, &H4E7437BC, &H82FCA6CA, &H90E0B0D0, &HA73315D8, &H4F14A98, &HEC41F7DA, &HCD7F0E50, &H91172FF6, _
        &H4D768DD6, &HEF434DB0, &HAACC544D, &H96E4DF04, &HD19EE3B5, &H6A4C1B88, &H2CC1B81F, &H65467F51, &H5E9D04EA, &H8C015D35, &H87FA7374, &HBFB2E41, &H67B35A1D, &HDB9252D2, &H10E93356, &HD66D1347, _
        &HD79A8C61, &HA1377A0C, &HF8598E14, &H13EB893C, &HA9CEEE27, &H61B735C9, &H1CE1EDE5, &H477A3CB1, &HD29C59DF, &HF2553F73, &H141879CE, &HC773BF37, &HF753EACD, &HFD5F5BAA, &H3DDF146F, &H447886DB, _
        &HAFCA81F3, &H68B93EC4, &H24382C34, &HA3C25F40, &H1D1672C3, &HE2BC0C25, &H3C288B49, &HDFF4195, &HA8397101, &HC08DEB3, &HB4D89CE4, &H566490C1, &HCB7B6184, &H32D570B6, &H6C48745C, &HB8D04257)

    mTd2Ptr = VarPtr(mTd2(0))
End Sub

Private Sub InitTd3()
    mTd3 = Cor.NewLongs( _
        &H5150A7F4, &H7E536541, &H1AC3A417, &H3A965E27, &H3BCB6BAB, &H1FF1459D, &HACAB58FA, &H4B9303E3, &H2055FA30, &HADF66D76, &H889176CC, &HF5254C02, &H4FFCD7E5, &HC5D7CB2A, &H26804435, &HB58FA362, _
        &HDE495AB1, &H25671BBA, &H45980EEA, &H5DE1C0FE, &HC302752F, &H8112F04C, &H8DA39746, &H6BC6F9D3, &H3E75F8F, &H15959C92, &HBFEB7A6D, &H95DA5952, &HD42D83BE, &H58D32174, &H492969E0, &H8E44C8C9, _
        &H756A89C2, &HF478798E, &H996B3E58, &H27DD71B9, &HBEB64FE1, &HF017AD88, &HC966AC20, &H7DB43ACE, &H63184ADF, &HE582311A, &H97603351, &H62457F53, &HB1E07764, &HBB84AE6B, &HFE1CA081, &HF9942B08, _
        &H70586848, &H8F19FD45, &H94876CDE, &H52B7F87B, &HAB23D373, &H72E2024B, &HE3578F1F, &H662AAB55, &HB20728EB, &H2F03C2B5, &H869A7BC5, &HD3A50837, &H30F28728, &H23B2A5BF, &H2BA6A03, &HED5C8216, _
        &H8A2B1CCF, &HA792B479, &HF3F0F207, &H4EA1E269, &H65CDF4DA, &H6D5BE05, &HD11F6234, &HC48AFEA6, &H349D532E, &HA2A055F3, &H532E18A, &HA475EBF6, &HB39EC83, &H40AAEF60, &H5E069F71, &HBD51106E, _
        &H3EF98A21, &H963D06DD, &HDDAE053E, &H4D46BDE6, &H91B58D54, &H71055DC4, &H46FD406, &H60FF1550, &H1924FB98, &HD697E9BD, &H89CC4340, &H67779ED9, &HB0BD42E8, &H7888B89, &HE7385B19, &H79DBEEC8, _
        &HA1470A7C, &H7CE90F42, &HF8C91E84, &H0&, &H9838680, &H3248ED2B, &H1EAC7011, &H6C4E725A, &HFDFBFF0E, &HF563885, &H3D1ED5AE, &H3627392D, &HA64D90F, &H6821A65C, &H9BD1545B, &H243A2E36, _
        &HCB1670A, &H930FE757, &HB4D296EE, &H1B9E919B, &H804FC5C0, &H61A220DC, &H5A694B77, &H1C161A12, &HE20ABA93, &HC0E52AA0, &H3C43E022, &H121D171B, &HE0B0D09, &HF2ADC78B, &H2DB9A8B6, &H14C8A91E, _
        &H578519F1, &HAF4C0775, &HEEBBDD99, &HA3FD607F, &HF79F2601, &H5CBCF572, &H44C53B66, &H5B347EFB, &H8B762943, &HCBDCC623, &HB668FCED, &HB863F1E4, &HD7CADC31, &H42108563, &H13402297, &H842011C6, _
        &H857D244A, &HD2F83DBB, &HAE1132F9, &HC76DA129, &H1D4B2F9E, &HDCF330B2, &HDEC5286, &H77D0E3C1, &H2B6C16B3, &HA999B970, &H11FA4894, &H472264E9, &HA8C48CFC, &HA01A3FF0, &H56D82C7D, &H22EF9033, _
        &H87C74E49, &HD9C1D138, &H8CFEA2CA, &H98360BD4, &HA6CF81F5, &HA528DE7A, &HDA268EB7, &H3FA4BFAD, &H2CE49D3A, &H500D9278, &H6A9BCC5F, &H5462467E, &HF6C2138D, &H90E8B8D8, &H2E5EF739, &H82F5AFC3, _
        &H9FBE805D, &H697C93D0, &H6FA92DD5, &HCFB31225, &HC83B99AC, &H10A77D18, &HE86E639C, &HDB7BBB3B, &HCD097826, &H6EF41859, &HEC01B79A, &H83A89A4F, &HE6656E95, &HAA7EE6FF, &H2108CFBC, &HEFE6E815, _
        &HBAD99BE7, &H4ACE366F, &HEAD4099F, &H29D67CB0, &H31AFB2A4, &H2A31233F, &HC63094A5, &H35C066A2, &H7437BC4E, &HFCA6CA82, &HE0B0D090, &H3315D8A7, &HF14A9804, &H41F7DAEC, &H7F0E50CD, &H172FF691, _
        &H768DD64D, &H434DB0EF, &HCC544DAA, &HE4DF0496, &H9EE3B5D1, &H4C1B886A, &HC1B81F2C, &H467F5165, &H9D04EA5E, &H15D358C, &HFA737487, &HFB2E410B, &HB35A1D67, &H9252D2DB, &HE9335610, &H6D1347D6, _
        &H9A8C61D7, &H377A0CA1, &H598E14F8, &HEB893C13, &HCEEE27A9, &HB735C961, &HE1EDE51C, &H7A3CB147, &H9C59DFD2, &H553F73F2, &H1879CE14, &H73BF37C7, &H53EACDF7, &H5F5BAAFD, &HDF146F3D, &H7886DB44, _
        &HCA81F3AF, &HB93EC468, &H382C3424, &HC25F40A3, &H1672C31D, &HBC0C25E2, &H288B493C, &HFF41950D, &H397101A8, &H8DEB30C, &HD89CE4B4, &H6490C156, &H7B6184CB, &HD570B632, &H48745C6C, &HD04257B8)

    mTd3Ptr = VarPtr(mTd3(0))
End Sub

Private Sub InitTd4()
    mTd4 = Cor.NewLongs( _
        &H52525252, &H9090909, &H6A6A6A6A, &HD5D5D5D5, &H30303030, &H36363636, &HA5A5A5A5, &H38383838, &HBFBFBFBF, &H40404040, &HA3A3A3A3, &H9E9E9E9E, &H81818181, &HF3F3F3F3, &HD7D7D7D7, &HFBFBFBFB, _
        &H7C7C7C7C, &HE3E3E3E3, &H39393939, &H82828282, &H9B9B9B9B, &H2F2F2F2F, &HFFFFFFFF, &H87878787, &H34343434, &H8E8E8E8E, &H43434343, &H44444444, &HC4C4C4C4, &HDEDEDEDE, &HE9E9E9E9, &HCBCBCBCB, _
        &H54545454, &H7B7B7B7B, &H94949494, &H32323232, &HA6A6A6A6, &HC2C2C2C2, &H23232323, &H3D3D3D3D, &HEEEEEEEE, &H4C4C4C4C, &H95959595, &HB0B0B0B, &H42424242, &HFAFAFAFA, &HC3C3C3C3, &H4E4E4E4E, _
        &H8080808, &H2E2E2E2E, &HA1A1A1A1, &H66666666, &H28282828, &HD9D9D9D9, &H24242424, &HB2B2B2B2, &H76767676, &H5B5B5B5B, &HA2A2A2A2, &H49494949, &H6D6D6D6D, &H8B8B8B8B, &HD1D1D1D1, &H25252525, _
        &H72727272, &HF8F8F8F8, &HF6F6F6F6, &H64646464, &H86868686, &H68686868, &H98989898, &H16161616, &HD4D4D4D4, &HA4A4A4A4, &H5C5C5C5C, &HCCCCCCCC, &H5D5D5D5D, &H65656565, &HB6B6B6B6, &H92929292, _
        &H6C6C6C6C, &H70707070, &H48484848, &H50505050, &HFDFDFDFD, &HEDEDEDED, &HB9B9B9B9, &HDADADADA, &H5E5E5E5E, &H15151515, &H46464646, &H57575757, &HA7A7A7A7, &H8D8D8D8D, &H9D9D9D9D, &H84848484, _
        &H90909090, &HD8D8D8D8, &HABABABAB, &H0, &H8C8C8C8C, &HBCBCBCBC, &HD3D3D3D3, &HA0A0A0A, &HF7F7F7F7, &HE4E4E4E4, &H58585858, &H5050505, &HB8B8B8B8, &HB3B3B3B3, &H45454545, &H6060606, _
        &HD0D0D0D0, &H2C2C2C2C, &H1E1E1E1E, &H8F8F8F8F, &HCACACACA, &H3F3F3F3F, &HF0F0F0F, &H2020202, &HC1C1C1C1, &HAFAFAFAF, &HBDBDBDBD, &H3030303, &H1010101, &H13131313, &H8A8A8A8A, &H6B6B6B6B, _
        &H3A3A3A3A, &H91919191, &H11111111, &H41414141, &H4F4F4F4F, &H67676767, &HDCDCDCDC, &HEAEAEAEA, &H97979797, &HF2F2F2F2, &HCFCFCFCF, &HCECECECE, &HF0F0F0F0, &HB4B4B4B4, &HE6E6E6E6, &H73737373, _
        &H96969696, &HACACACAC, &H74747474, &H22222222, &HE7E7E7E7, &HADADADAD, &H35353535, &H85858585, &HE2E2E2E2, &HF9F9F9F9, &H37373737, &HE8E8E8E8, &H1C1C1C1C, &H75757575, &HDFDFDFDF, &H6E6E6E6E, _
        &H47474747, &HF1F1F1F1, &H1A1A1A1A, &H71717171, &H1D1D1D1D, &H29292929, &HC5C5C5C5, &H89898989, &H6F6F6F6F, &HB7B7B7B7, &H62626262, &HE0E0E0E, &HAAAAAAAA, &H18181818, &HBEBEBEBE, &H1B1B1B1B, _
        &HFCFCFCFC, &H56565656, &H3E3E3E3E, &H4B4B4B4B, &HC6C6C6C6, &HD2D2D2D2, &H79797979, &H20202020, &H9A9A9A9A, &HDBDBDBDB, &HC0C0C0C0, &HFEFEFEFE, &H78787878, &HCDCDCDCD, &H5A5A5A5A, &HF4F4F4F4, _
        &H1F1F1F1F, &HDDDDDDDD, &HA8A8A8A8, &H33333333, &H88888888, &H7070707, &HC7C7C7C7, &H31313131, &HB1B1B1B1, &H12121212, &H10101010, &H59595959, &H27272727, &H80808080, &HECECECEC, &H5F5F5F5F, _
        &H60606060, &H51515151, &H7F7F7F7F, &HA9A9A9A9, &H19191919, &HB5B5B5B5, &H4A4A4A4A, &HD0D0D0D, &H2D2D2D2D, &HE5E5E5E5, &H7A7A7A7A, &H9F9F9F9F, &H93939393, &HC9C9C9C9, &H9C9C9C9C, &HEFEFEFEF, _
        &HA0A0A0A0, &HE0E0E0E0, &H3B3B3B3B, &H4D4D4D4D, &HAEAEAEAE, &H2A2A2A2A, &HF5F5F5F5, &HB0B0B0B0, &HC8C8C8C8, &HEBEBEBEB, &HBBBBBBBB, &H3C3C3C3C, &H83838383, &H53535353, &H99999999, &H61616161, _
        &H17171717, &H2B2B2B2B, &H4040404, &H7E7E7E7E, &HBABABABA, &H77777777, &HD6D6D6D6, &H26262626, &HE1E1E1E1, &H69696969, &H14141414, &H63636363, &H55555555, &H21212121, &HC0C0C0C, &H7D7D7D7D)

    mTd4Ptr = VarPtr(mTd4(0))
End Sub
    
Private Sub InitRCon()
    mRCon = Cor.NewLongs(&H1, &H2, &H4, &H8, &H10, &H20, &H40, &H80, &H1B, _
            &H36, &H6C, &HD8, &HAB, &H4D, &H9A, &H2F, &H5E, &HBC, &H63, _
            &HC6, &H97, &H35, &H6A, &HD4, &HB3, &H7D, &HFA, &HEF, &HC5)

    mRConPtr = SAPtr(mRCon)
End Sub

Private Sub InitSBox()
    mSBox = Cor.NewBytes( _
            &H63, &H7C, &H77, &H7B, &HF2, &H6B, &H6F, &HC5, &H30, &H1, &H67, &H2B, &HFE, &HD7, &HAB, &H76, _
            &HCA, &H82, &HC9, &H7D, &HFA, &H59, &H47, &HF0, &HAD, &HD4, &HA2, &HAF, &H9C, &HA4, &H72, &HC0, _
            &HB7, &HFD, &H93, &H26, &H36, &H3F, &HF7, &HCC, &H34, &HA5, &HE5, &HF1, &H71, &HD8, &H31, &H15, _
            &H4, &HC7, &H23, &HC3, &H18, &H96, &H5, &H9A, &H7, &H12, &H80, &HE2, &HEB, &H27, &HB2, &H75, _
            &H9, &H83, &H2C, &H1A, &H1B, &H6E, &H5A, &HA0, &H52, &H3B, &HD6, &HB3, &H29, &HE3, &H2F, &H84, _
            &H53, &HD1, &H0, &HED, &H20, &HFC, &HB1, &H5B, &H6A, &HCB, &HBE, &H39, &H4A, &H4C, &H58, &HCF, _
            &HD0, &HEF, &HAA, &HFB, &H43, &H4D, &H33, &H85, &H45, &HF9, &H2, &H7F, &H50, &H3C, &H9F, &HA8, _
            &H51, &HA3, &H40, &H8F, &H92, &H9D, &H38, &HF5, &HBC, &HB6, &HDA, &H21, &H10, &HFF, &HF3, &HD2, _
            &HCD, &HC, &H13, &HEC, &H5F, &H97, &H44, &H17, &HC4, &HA7, &H7E, &H3D, &H64, &H5D, &H19, &H73, _
            &H60, &H81, &H4F, &HDC, &H22, &H2A, &H90, &H88, &H46, &HEE, &HB8, &H14, &HDE, &H5E, &HB, &HDB, _
            &HE0, &H32, &H3A, &HA, &H49, &H6, &H24, &H5C, &HC2, &HD3, &HAC, &H62, &H91, &H95, &HE4, &H79, _
            &HE7, &HC8, &H37, &H6D, &H8D, &HD5, &H4E, &HA9, &H6C, &H56, &HF4, &HEA, &H65, &H7A, &HAE, &H8, _
            &HBA, &H78, &H25, &H2E, &H1C, &HA6, &HB4, &HC6, &HE8, &HDD, &H74, &H1F, &H4B, &HBD, &H8B, &H8A, _
            &H70, &H3E, &HB5, &H66, &H48, &H3, &HF6, &HE, &H61, &H35, &H57, &HB9, &H86, &HC1, &H1D, &H9E, _
            &HE1, &HF8, &H98, &H11, &H69, &HD9, &H8E, &H94, &H9B, &H1E, &H87, &HE9, &HCE, &H55, &H28, &HDF, _
            &H8C, &HA1, &H89, &HD, &HBF, &HE6, &H42, &H68, &H41, &H99, &H2D, &HF, &HB0, &H54, &HBB, &H16)

    mSBoxPtr = SAPtr(mSBox)
End Sub


